
#include "Arduino.h"
volatile uint16_t icr_1, ocra_1, icr_11, ocra_11;
volatile int16_t input=0;
uint32_t period1;
uint16_t diviseur[6] = {0,1,8,64,256,1024};
uint8_t d1,d4,d3;
float Th;
float Go;

float fo = 731; // fréquence de référence
float Ko = 40.0; // gain de l'OCT (en rad/V/s)

void setup() {
  Serial.begin(115200);
DDRB |= 1 << PORTB5; // OC1A (timer 1) configurée en sortie (D11)

cli(); // désactivation des interruptions
// Configuration de l'OCT
// Oscillation générée avec Timer1 (sortie D11)
TCCR1A = 0;
TCCR1A |= (1 << COM1A1) ;// clear OC1A on compare match when up-counting, reset OC1A on compare match when down-counting
TCCR1B = 1 << WGM13; // phase and frequency correct pwm mode, top = ICR1
period1 = 1/fo*1e6; // période en microsecondes
d1 = 1;
icr_1 = (F_CPU/1000000*period1/2/diviseur[d1]); // valeur maximale du compteur, pour définir la période
Th = 1.0/(F_CPU/1000000/diviseur[d1]); // période de l'horloge (en us)
Go = 5.0*Ko/(2*PI*1024)*period1*1e-6;
ocra_1 = icr_1/2; // rapport cyclique = 1/2
ICR1 = icr_1;
OCR1A = ocra_1;
TIMSK1 = 1 << TOIE1; // overflow interrupt enable
TCCR1B |= d1; // déclenchement du compteur avec choix du diviseur d'horloge


// configuration de l'ADC
ADCSRA = 0;
ADCSRA |= (1 << ADEN); // enable ADC
ADCSRA |= 0 ; // prescaler
ADCSRB = 0;
ADMUX = 0b01000000 | 0; // REFS0 et ADC0
ADCSRA |= 0b01000000; // start ADC
sei();// activation des interruptions
}

// Changement de la fréquence de l'OCT à chaque cycle
ISR(TIMER1_OVF_vect) { // Timer 1 Overflow interrupt
  input = ADCL | (ADCH <<8);
  icr_11 = 1.0*icr_1/(1+Go*(input*1.0-512));
  ocra_11 = icr_11/2;
  ICR1 = icr_11;
  OCR1A = ocra_11;
  ADCSRA |= 0b01000000; // start ADC
}

void loop() {
  delay(500);
  float f = 16e6/(icr_11*2*diviseur[d1]);
  Serial.print(f); Serial.println(" Hz"); 
}
    	   